| http://www.sim.no/ http://www.coin3d.org/

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes | List of all members
SoSTLFileKit Class Reference

SoSTLFileKit is a class for using STL files with Coin. More...

`#include <ForeignFiles/SoSTLFileKit.h>`

Inheritance diagram for SoSTLFileKit:

## Public Types

enum | Colorization { GREY, MATERIALISE, TNO_VISICAM }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000, VRML1 = 0x0001, VRML2 = 0x0002, INVENTOR_1 = 0x0004, INVENTOR_2_0 = 0x0008, INVENTOR_2_1 = 0x0010, INVENTOR_2_5 = 0x0020, INVENTOR_2_6 = 0x0040, COIN_1_0 = 0x0080, COIN_2_0 = 0x0100, EXTENSION = 0x0200, COIN_2_2 = 0x0400, COIN_2_3 = 0x0800, COIN_2_4 = 0x1000, INVENTOR_5_0 = 0x2000, COIN_2_5 = 0x4000, COIN_3_0 = 0x8000, INVENTOR_6_0 = 0x10000 }

## Public Member Functions

virtual SoType | getTypeId (void) const
virtual const SoNodekitCatalog * | getNodekitCatalog (void) const
| SoSTLFileKit (void)
virtual SbBool | canReadFile (const char *filename=NULL) const
virtual SbBool | readFile (const char *filename)
virtual SbBool | canReadScene (void) const
virtual SbBool | readScene (SoNode *scene)
virtual SbBool | canWriteFile (const char *filename=NULL) const
virtual SbBool | writeFile (const char *filename)
virtual SbBool | canWriteScene (const char *format=NULL) const
virtual SbBool | writeScene (SoNode *&root, const char *format=NULL)
Public Member Functions inherited from SoBaseKit
| SoBaseKit (void)
virtual SoNode * | getPart (const SbName &partname, SbBool makeifneeded)
SbString | getPartString (const SoBase *part)
virtual SoNodeKitPath * | createPathToPart (const SbName &partname, SbBool makeifneeded, const SoPath *pathtoextend=NULL)
virtual SbBool | setPart (const SbName &partname, SoNode *from)
SbBool | set (const char *namevaluepairliststring)
SbBool | set (const char *partnamestring, const char *parameterstring)
virtual void | doAction (SoAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SoChildList * | getChildren (void) const
void | printDiagram (void)
void | printSubDiagram (const SbName &rootname, int level)
void | printTable (void)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | forceChildDrivenWriteRefs (SoOutput *out)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
uint32_t | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions

static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
static SbBool | identify (const char *filename)
Static Public Member Functions inherited from SoForeignFileKit
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
static SbBool | isFileSupported (SoInput *in, SbBool exhaust=FALSE)
static SoForeignFileKit * | createForeignFileKit (SoInput *in, SbBool exhaust=FALSE)
static SbBool | isFileSupported (const char *filename, SbBool exhaust=FALSE)
static SoForeignFileKit * | createForeignFileKit (const char *filename, SbBool exhaust=FALSE)
Static Public Member Functions inherited from SoBaseKit
static SoType | getClassTypeId (void)
static void | initClass (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static SbBool | isSearchingChildren (void)
static void | setSearchingChildren (const SbBool newval)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
static void | initClasses (void)
static uint32_t | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
static SoType | getClassTypeId (void)
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes

SoSFString | info
SoSFBool | binary
SoSFEnum | colorization
Public Attributes inherited from SoForeignFileKit
SoSFString | filename

## Protected Member Functions

virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoSTLFileKit (void)
void | reset (void)
SbBool | addFacet (const SbVec3f &v1, const SbVec3f &v2, const SbVec3f &v3, const SbVec3f &normal)
void | organizeModel (void)
Protected Member Functions inherited from SoBaseKit
virtual | ~SoBaseKit ()
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *fromfc, SbBool copyconnections)
SoGroup * | getContainerNode (const SbName &listname, SbBool makeifneeded=TRUE)
virtual SoNode * | getAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SoNodeKitPath * | createPathToAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE, const SoPath *pathtoextend=NULL)
virtual SbBool | setAnyPart (const SbName &partname, SoNode *from, SbBool anypart=TRUE)
void | createNodekitPartsList (void)
void | createFieldList (void)
virtual void | createDefaultParts (void)
const SoNodekitParts * | getNodekitPartsList (void) const
const SbList< SoSFNode * > & | getCatalogInstances (void) const
void | catalogError (void)
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual void | setDefaultOnNonWritingFields (void)
void | countMyFields (SoOutput *out)
virtual SbBool | setPart (const int partNum, SoNode *node)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const

## Static Protected Member Functions

static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
Static Protected Member Functions inherited from SoForeignFileKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | initClasses (void)
static SbBool | registerFileExtension (SoType handler, SbName extension, SoForeignFileIdentifyFunc *identify)
Static Protected Member Functions inherited from SoBaseKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes

SoSFNode | shapehints
SoSFNode | texture
SoSFNode | normalbinding
SoSFNode | normals
SoSFNode | materialbinding
SoSFNode | material
SoSFNode | coordinates
SoSFNode | facets
Protected Attributes inherited from SoForeignFileKit
SoSFNode | topSeparator
Protected Attributes inherited from SoBaseKit
SoSFNode | callbackList
SoChildList * | children
SbBool | connectionsSetUp
Protected Attributes inherited from SoNode
uint32_t | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members

Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01, IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static uint32_t | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

SoSTLFileKit is a class for using STL files with Coin.

Class for using STL files with Coin. You can use it to read and write STL files, and convert back and forth between Open Inventor scene graphs and SoSTLFileKits.

STL files are 3D models intended for 3D printers, and is a format supported by a wide variety of computer-aided design programs. STL models are, because of their intended purpose, always representations of solid objects. STL is short for Stereolithography, the process used for 3D printing.

Ordinary STL models do not contain color information. There are, however, two extensions to the binary file format for specifying color. Currently neither extension is supported. This is caused by lack of sample models using the extensions and will be added as soon as such models are found. We have the specs on the extensions, and it should be pretty straight-forwards to implement, but we want to get it right at once since we have write support (we don't want to inadvertently create a third color extension ;).

When writing STL files, certain STL model criterias are not enforced by SoSTLFileKit. These are:

- STL models should represent complete solids - it is the user's responsibility to give models of solid data to readScene(), and not readScene()'s responsibility to check the incoming data.
- STL models should have all triangles in counterclockwise order. This is not enforced either.
- STL models should reside in the positive octant of the coordinate space. This is also the user's responsibility to ensure, although adding functionality for translating the model should be easy, so it might get implemented.

Since the color extensions are not supported yet, color information is not collected either when converting Open Inventor scene graphs to SoSTLFileKits.

Be aware that this class is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since
  Coin 3.0

## Constructor & Destructor Documentation

## ◆ SoSTLFileKit()

SoSTLFileKit::SoSTLFileKit | ( | void |  | ) |

Constructor.

## ◆ ~SoSTLFileKit()

SoSTLFileKit::~SoSTLFileKit | ( | void |  | ) |

protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getTypeId()

SoType SoSTLFileKit::getTypeId | ( | void |  | ) | const

virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for run-time type checking and "downward" casting.

Usage example:

void foo(SoNode * node)
{
if (node->getTypeId() == SoFile::getClassTypeId()) {
SoFile * filenode = (SoFile *)node; // safe downward cast, knows the type
}
}

For application programmers wanting to extend the library with new nodes, engines, nodekits, draggers or others: this method needs to be overridden in all subclasses. This is typically done as part of setting up the full type system for extension classes, which is usually accomplished by using the pre-defined macros available through for instance Inventor/nodes/SoSubNode.h (SO_NODE_INIT_CLASS and SO_NODE_CONSTRUCTOR for node classes), Inventor/engines/SoSubEngine.h (for engine classes) and so on.

For more information on writing Coin extensions, see the class documentation of the toplevel superclasses for the various class groups.

Reimplemented from SoForeignFileKit.

## ◆ getFieldData()

const SoFieldData * SoSTLFileKit::getFieldData | ( | void |  | ) | const

protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoForeignFileKit.

## ◆ getNodekitCatalog()

const SoNodekitCatalog * SoSTLFileKit::getNodekitCatalog | ( | void |  | ) | const

virtual

Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoForeignFileKit.

## ◆ initClass()

void SoSTLFileKit::initClass | ( | void |  | ) |

static

Initializes class and registers file identification functions.

## ◆ identify()

SbBool SoSTLFileKit::identify | ( | const char * | filename | ) |

static

Returns wether or not filename is identified as an STL file.

## ◆ readFile()

SbBool SoSTLFileKit::readFile | ( | const char * | filename | ) |

virtual

Reads in an STL file. Both ascii and binary files are supported. For binary files, the color extensions are not implemented yet.

Returns FALSE if filename could not be opened or parsed correctly.

See also
  canReadFile, canWriteScene, writeScene

Reimplemented from SoForeignFileKit.

## ◆ readScene()

SbBool SoSTLFileKit::readScene | ( | SoNode * | scene | ) |

virtual

Converts a scene graph into an SoSTLFileKit. Useful for creating STL files.

See also
  canReadScene, canWriteFile, writeFile

Reimplemented from SoForeignFileKit.

## ◆ writeFile()

SbBool SoSTLFileKit::writeFile | ( | const char * | filename | ) |

virtual

Writes the STL model to an STL file.

See also
  binary, info, canWriteFile, canReadScene

Reimplemented from SoForeignFileKit.

## ◆ writeScene()

SbBool SoSTLFileKit::writeScene | ( | SoNode *& | root,
|  | const char * | format = `NULL`
| ) |  |

virtual

Converts the STL model into a native scene graph.

See also
  canWriteScene

Reimplemented from SoForeignFileKit.

## ◆ reset()

void SoSTLFileKit::reset | ( | void |  | ) |

protected

Resets the STL model so it contains nothing.

## ◆ addFacet()

SbBool SoSTLFileKit::addFacet | ( | const SbVec3f & | v1,
|  | const SbVec3f & | v2,
|  | const SbVec3f & | v3,
|  | const SbVec3f & | n
| ) |  |

protected

Adds one triangle to the STL model.

See also
  reset, organizeModel

## ◆ organizeModel()

void SoSTLFileKit::organizeModel | ( | void |  | ) |

protected

Should be called after the STL model is completely set up in the SoSTLFileKit through import from a file or from a scene graph. The model will then be optimized for fast rendering.

See also
  addFacet, reset

The documentation for this class was generated from the following files:

- SoSTLFileKit.h
- SoSTLFileKit.cpp

Copyright © 1998-2010 by Kongsberg Oil & Gas Technologies. All rights reserved.